package org.codehaus.mojo.make;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on make-maven-plugin.<br/> Call <pre>  mvn make:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Sat May 30 14:58:58 CDT 2009
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.5)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.mojo:make-maven-plugin:1.0-beta-1", 0 );
        append( sb, "", 0 );

        append( sb, "Makefile Orchestration Plugin", 0 );
        append( sb, "These plugins are designed to convert tarballs of typical non-java open source project and with patch/autoconf/configure/make/install prepare a directory for packaging with RPM. Stuffing a java project into an RPM is also supported.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 12 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "autoreconf".equals( goal ) )
        {
            append( sb, "make:autoreconf", 0 );
            append( sb, "Execute autoreconf with command line arguments.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "arguments", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "environment", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "workDir (Default: ${project.build.directory})", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "chmod".equals( goal ) )
        {
            append( sb, "make:chmod", 0 );
            append( sb, "Change the file/directory mode on a list of files.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "chmodPaths", 2 );
                append( sb, "The list of paths to chmod.", 3 );
                append( sb, "", 0 );

                append( sb, "mode (Default: +x)", 2 );
                append( sb, "The chmod mode to use.", 3 );
                append( sb, "", 0 );

                append( sb, "recursive (Default: false)", 2 );
                append( sb, "Whether to execute recursively, as in the case where directories are being targeted.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "chown".equals( goal ) )
        {
            append( sb, "make:chown", 0 );
            append( sb, "Change the ownership on a set of paths. Assumes you have sudo installed and configured.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "chownPaths", 2 );
                append( sb, "The list of paths to chown.", 3 );
                append( sb, "", 0 );

                append( sb, "group", 2 );
                append( sb, "The group to use.", 3 );
                append( sb, "", 0 );

                append( sb, "recursive (Default: false)", 2 );
                append( sb, "Whether to execute recursively, as in the case where directories are being targeted.", 3 );
                append( sb, "", 0 );

                append( sb, "user (Default: ${user.name})", 2 );
                append( sb, "The user to use.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "compile".equals( goal ) )
        {
            append( sb, "make:compile", 0 );
            append( sb, "Execute a Make-ish compile target to generate binaries from the project source.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "absoluteCommandPathUsed (Default: false)", 2 );
                append( sb, "Behavior to take command and use explicit pathing instead of using the shell\'s path", 3 );
                append( sb, "", 0 );

                append( sb, "absoluteCompileCommand (Default: false)", 2 );
                append( sb, "Whether to use an absolute path for the compile command or not. If the compile command\'s file is not found in the workDir, this is a moot point.", 3 );
                append( sb, "", 0 );

                append( sb, "chmodCompileCommand", 2 );
                append( sb, "Whether to set the Executable bit for the compile command.", 3 );
                append( sb, "", 0 );

                append( sb, "chmodUsed (Default: false)", 2 );
                append( sb, "Configures the goal to change the make command to executable prior to invocation", 3 );
                append( sb, "", 0 );

                append( sb, "command (Default: make)", 2 );
                append( sb, "The shell command to execute. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "compileCheckFile", 2 );
                append( sb, "A check file that will be monitored to verify modification before allowing the compile execution to succeed. If empty, this option is not used.", 3 );
                append( sb, "", 0 );

                append( sb, "compileCommand", 2 );
                append( sb, "The actual shell command to run in order to compile the sources; defaults to \'make\'.", 3 );
                append( sb, "", 0 );

                append( sb, "compileEnvironment", 2 );
                append( sb, "Environment variables that should be present in the compile command\'s shell. Any \'@pathOf(groupId:artifactId)@\' references will be resolved before the command is executed.", 3 );
                append( sb, "", 0 );

                append( sb, "compileOptions", 2 );
                append( sb, "The list of command-line arguments to supply for the command invocation. No expressions are currently allowed here, beyond those resolved inside the pom.xml.", 3 );
                append( sb, "", 0 );

                append( sb, "compileTarget", 2 );
                append( sb, "The Make target to execute. In many cases, this doesn\'t have to be supplied, since the default target commonly compiles the code.", 3 );
                append( sb, "", 0 );

                append( sb, "destDir", 2 );
                append( sb, "The classic autoconf/make DESTDIR parameter which tells make to stage the installation to a temp directory prior to packaging (allows for package building without root access). DESTDIR is called a staged installation by the GNU coding standards", 3 );
                append( sb, "", 0 );

                append( sb, "environment", 2 );
                append( sb, "make-maven-plugin will define environment variables prior to execution of the commands that it dispatches", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreErrors (Default: false)", 2 );
                append( sb, "Configures the goal to ignore errors returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreFailures (Default: false)", 2 );
                append( sb, "Configures the goal to ignore failures returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "makeCompileWorkDir", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );

                append( sb, "options", 2 );
                append( sb, "The command-line arguments to include in the command invocation. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "resolveOptions (Default: true)", 2 );
                append( sb, "resolveOptions is a setting to control if you want the make-maven-plugin to resolve @pathOf(..)@ expressions or not", 3 );
                append( sb, "", 0 );

                append( sb, "searchForExecutable (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "skipCompile (Default: false)", 2 );
                append( sb, "Whether we should skip the Make compile step for this project. This is merely a short-circuit mechanism, since this mojo will be included in a standard lifecycle mapping.", 3 );
                append( sb, "", 0 );

                append( sb, "skipped (Default: false)", 2 );
                append( sb, "If set, the goal will be skipped", 3 );
                append( sb, "", 0 );

                append( sb, "workDir (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "configure".equals( goal ) )
        {
            append( sb, "make:configure", 0 );
            append( sb, "Execute the configure (or similar) script to prepare the project directory for Make execution (or similar).", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "absoluteCommandPathUsed (Default: false)", 2 );
                append( sb, "Behavior to take command and use explicit pathing instead of using the shell\'s path", 3 );
                append( sb, "", 0 );

                append( sb, "absoluteConfigureCommand (Default: false)", 2 );
                append( sb, "Whether the configure command should be referenced as an absolute path or not. Default is false.", 3 );
                append( sb, "", 0 );

                append( sb, "chmodConfigureCommand (Default: true)", 2 );
                append( sb, "Whether to set the Executable bit for the configure script on the filesystem.", 3 );
                append( sb, "", 0 );

                append( sb, "chmodUsed (Default: false)", 2 );
                append( sb, "Configures the goal to change the make command to executable prior to invocation", 3 );
                append( sb, "", 0 );

                append( sb, "command (Default: make)", 2 );
                append( sb, "The shell command to execute. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "configureCheckFile", 2 );
                append( sb, "This is a file location checked before and after the configure execution, if specified. If the file is not touched during configuration, this mojo will fail.", 3 );
                append( sb, "", 0 );

                append( sb, "configureCommand (Default: ./configure)", 2 );
                append( sb, "The command path. The default is \'./configure\' in the work directory.", 3 );
                append( sb, "", 0 );

                append( sb, "configureEnvironment", 2 );
                append( sb, "These are environment variables you want added to the configure command\'s execution shell. They will be resolved in the same manner as configureOptions, where \'@pathOf(groupId:artifactId)@\' is resolved to the prefix of that dependency.", 3 );
                append( sb, "", 0 );

                append( sb, "configureOptions", 2 );
                append( sb, "The list of command-line arguments to the configuration script. An example might be:\n\'--with-ssl=\npath/to/openssl\'\nNOTE: The expressions \'@destDir@\' and \'@pathOf(groupId:artifactId)@\' are available for use here. The first will substitute the value of the destDir parameter (described below) in place of the token, and the second will substitute the systemPath of the dependency referenced by groupId:artifactId for the expression. For example:\n\n\'--ssldir=@destDir@\' \'--with-ssl=@pathOf(org.openssl:openssl)@\'\n", 3 );
                append( sb, "", 0 );

                append( sb, "configureWorkDir", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );

                append( sb, "destDir", 2 );
                append( sb, "The classic autoconf/make DESTDIR parameter which tells make to stage the installation to a temp directory prior to packaging (allows for package building without root access). DESTDIR is called a staged installation by the GNU coding standards", 3 );
                append( sb, "", 0 );

                append( sb, "environment", 2 );
                append( sb, "make-maven-plugin will define environment variables prior to execution of the commands that it dispatches", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreErrors (Default: false)", 2 );
                append( sb, "Configures the goal to ignore errors returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreFailures (Default: false)", 2 );
                append( sb, "Configures the goal to ignore failures returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "options", 2 );
                append( sb, "The command-line arguments to include in the command invocation. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "prefix", 2 );
                append( sb, "The configure prefix, to let the RPM harvester know how to build the dir structure.", 3 );
                append( sb, "", 0 );

                append( sb, "prefixOption (Default: --prefix)", 2 );
                append( sb, "The prefix option. The default is \'--prefix\'.", 3 );
                append( sb, "", 0 );

                append( sb, "resolveOptions (Default: true)", 2 );
                append( sb, "resolveOptions is a setting to control if you want the make-maven-plugin to resolve @pathOf(..)@ expressions or not", 3 );
                append( sb, "", 0 );

                append( sb, "searchForConfigureCommand (Default: true)", 2 );
                append( sb, "Whether the workDir and other locations should be searched for the configure executable.", 3 );
                append( sb, "", 0 );

                append( sb, "searchForExecutable (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "skipConfigure (Default: false)", 2 );
                append( sb, "Whether we should skip the configuration step of the Make process for this project. This is merely a short-circuit mechanism, since this mojo will be included in a standard lifecycle mapping.", 3 );
                append( sb, "", 0 );

                append( sb, "skipped (Default: false)", 2 );
                append( sb, "If set, the goal will be skipped", 3 );
                append( sb, "", 0 );

                append( sb, "workDir (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "make:help", 0 );
            append( sb, "Display help information on make-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0make:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "make-clean".equals( goal ) )
        {
            append( sb, "make:make-clean", 0 );
            append( sb, "Remove from source directory all files generated during the make process.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "absoluteCommandPathUsed (Default: false)", 2 );
                append( sb, "Behavior to take command and use explicit pathing instead of using the shell\'s path", 3 );
                append( sb, "", 0 );

                append( sb, "chmodUsed (Default: false)", 2 );
                append( sb, "Configures the goal to change the make command to executable prior to invocation", 3 );
                append( sb, "", 0 );

                append( sb, "cleanBinaries (Default: true)", 2 );
                append( sb, "Whether we should remove the program binaries and object files from the source code directory.", 3 );
                append( sb, "", 0 );

                append( sb, "cleanConfig (Default: false)", 2 );
                append( sb, "Whether we should remove the files that the configuration process generated.", 3 );
                append( sb, "", 0 );

                append( sb, "command (Default: make)", 2 );
                append( sb, "The shell command to execute. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "destDir", 2 );
                append( sb, "The classic autoconf/make DESTDIR parameter which tells make to stage the installation to a temp directory prior to packaging (allows for package building without root access). DESTDIR is called a staged installation by the GNU coding standards", 3 );
                append( sb, "", 0 );

                append( sb, "environment", 2 );
                append( sb, "make-maven-plugin will define environment variables prior to execution of the commands that it dispatches", 3 );
                append( sb, "", 0 );

                append( sb, "filesets", 2 );
                append( sb, "The list of filesets to delete, in addition to the default directories.", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreErrors (Default: false)", 2 );
                append( sb, "Configures the goal to ignore errors returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreFailures (Default: false)", 2 );
                append( sb, "Configures the goal to ignore failures returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "makeWorkDir", 2 );
                append( sb, "The temporary working directory where the project is actually built.", 3 );
                append( sb, "", 0 );

                append( sb, "options", 2 );
                append( sb, "The command-line arguments to include in the command invocation. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "resolveOptions (Default: true)", 2 );
                append( sb, "resolveOptions is a setting to control if you want the make-maven-plugin to resolve @pathOf(..)@ expressions or not", 3 );
                append( sb, "", 0 );

                append( sb, "searchForExecutable (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "skipped (Default: false)", 2 );
                append( sb, "If set, the goal will be skipped", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Be verbose in the debug log-level?", 3 );
                append( sb, "", 0 );

                append( sb, "workDir (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "make-dist".equals( goal ) )
        {
            append( sb, "make:make-dist", 0 );
            append( sb, "(no description available)", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "absoluteCommandPathUsed (Default: false)", 2 );
                append( sb, "Behavior to take command and use explicit pathing instead of using the shell\'s path", 3 );
                append( sb, "", 0 );

                append( sb, "chmodUsed (Default: false)", 2 );
                append( sb, "Configures the goal to change the make command to executable prior to invocation", 3 );
                append( sb, "", 0 );

                append( sb, "command (Default: make)", 2 );
                append( sb, "The shell command to execute. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "destDir", 2 );
                append( sb, "The classic autoconf/make DESTDIR parameter which tells make to stage the installation to a temp directory prior to packaging (allows for package building without root access). DESTDIR is called a staged installation by the GNU coding standards", 3 );
                append( sb, "", 0 );

                append( sb, "distCommand (Default: make)", 2 );
                append( sb, "The command to execute the \'make\' program.", 3 );
                append( sb, "", 0 );

                append( sb, "distOptions", 2 );
                append( sb, "Commandline options for the execution of make.", 3 );
                append( sb, "", 0 );

                append( sb, "distTarget (Default: dist)", 2 );
                append( sb, "The make target to execute.", 3 );
                append( sb, "", 0 );

                append( sb, "environment", 2 );
                append( sb, "make-maven-plugin will define environment variables prior to execution of the commands that it dispatches", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreErrors (Default: false)", 2 );
                append( sb, "Configures the goal to ignore errors returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreFailures (Default: false)", 2 );
                append( sb, "Configures the goal to ignore failures returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "options", 2 );
                append( sb, "The command-line arguments to include in the command invocation. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "resolveOptions (Default: true)", 2 );
                append( sb, "resolveOptions is a setting to control if you want the make-maven-plugin to resolve @pathOf(..)@ expressions or not", 3 );
                append( sb, "", 0 );

                append( sb, "searchForExecutable (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "skipDist (Default: true)", 2 );
                append( sb, "Set this parameter to skip calling \'make dist\' which will create a release tarball", 3 );
                append( sb, "", 0 );

                append( sb, "skipped (Default: false)", 2 );
                append( sb, "If set, the goal will be skipped", 3 );
                append( sb, "", 0 );

                append( sb, "sourceArchive (Default: ${project.artifactId}-${project.version}.tar.gz)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "sourceArchivePath (Default: ${basedir}/src/main/project)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "workDir (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "make-install".equals( goal ) )
        {
            append( sb, "make:make-install", 0 );
            append( sb, "Execute a Make-ish install target to assemble the compiled binaries into a temporary destination directory (work dir) for harvesting by a packager of some sort (like RPM).", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "absoluteCommandPathUsed (Default: false)", 2 );
                append( sb, "Behavior to take command and use explicit pathing instead of using the shell\'s path", 3 );
                append( sb, "", 0 );

                append( sb, "chmodInstallCommand", 2 );
                append( sb, "Whether to set the Executable bit for the install command.", 3 );
                append( sb, "", 0 );

                append( sb, "chmodUsed (Default: false)", 2 );
                append( sb, "Configures the goal to change the make command to executable prior to invocation", 3 );
                append( sb, "", 0 );

                append( sb, "command (Default: make)", 2 );
                append( sb, "The shell command to execute. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "destDir", 2 );
                append( sb, "The classic autoconf/make DESTDIR parameter which tells make to stage the installation to a temp directory prior to packaging (allows for package building without root access). DESTDIR is called a staged installation by the GNU coding standards", 3 );
                append( sb, "", 0 );

                append( sb, "environment", 2 );
                append( sb, "make-maven-plugin will define environment variables prior to execution of the commands that it dispatches", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreErrors (Default: false)", 2 );
                append( sb, "Configures the goal to ignore errors returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreFailures (Default: false)", 2 );
                append( sb, "Configures the goal to ignore failures returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "installCheckFile", 2 );
                append( sb, "An optional check file to monitor before and after the installation process. If this file is specified and is not changed during installation to the work directory, the mojo fails.", 3 );
                append( sb, "", 0 );

                append( sb, "installCommand", 2 );
                append( sb, "Shell command used to install the project binaries into the work directory.", 3 );
                append( sb, "", 0 );

                append( sb, "installEnvironment", 2 );
                append( sb, "Shell environment variables used in the install command invocation.", 3 );
                append( sb, "", 0 );

                append( sb, "installOptions", 2 );
                append( sb, "Command-line options used in the install command invocation.", 3 );
                append( sb, "", 0 );

                append( sb, "installTarget", 2 );
                append( sb, "The Make target which should be executed; default is \'install\'", 3 );
                append( sb, "", 0 );

                append( sb, "makeInstallWorkDir", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );

                append( sb, "options", 2 );
                append( sb, "The command-line arguments to include in the command invocation. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "resolveOptions (Default: true)", 2 );
                append( sb, "resolveOptions is a setting to control if you want the make-maven-plugin to resolve @pathOf(..)@ expressions or not", 3 );
                append( sb, "", 0 );

                append( sb, "searchForExecutable (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "skipInstall (Default: false)", 2 );
                append( sb, "Whether we should skip the install target of the Make process for this project. This is merely a short-circuit mechanism, since this mojo will be included in a standard lifecycle mapping.", 3 );
                append( sb, "", 0 );

                append( sb, "skipped (Default: false)", 2 );
                append( sb, "If set, the goal will be skipped", 3 );
                append( sb, "", 0 );

                append( sb, "workDir (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "test".equals( goal ) )
        {
            append( sb, "make:test", 0 );
            append( sb, "Execute a Make (or similar) target to test the compiled binary.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "absoluteCommandPathUsed (Default: false)", 2 );
                append( sb, "Behavior to take command and use explicit pathing instead of using the shell\'s path", 3 );
                append( sb, "", 0 );

                append( sb, "chmodTestCommand", 2 );
                append( sb, "Whether to set the Executable bit for the test command.", 3 );
                append( sb, "", 0 );

                append( sb, "chmodUsed (Default: false)", 2 );
                append( sb, "Configures the goal to change the make command to executable prior to invocation", 3 );
                append( sb, "", 0 );

                append( sb, "command (Default: make)", 2 );
                append( sb, "The shell command to execute. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "destDir", 2 );
                append( sb, "The classic autoconf/make DESTDIR parameter which tells make to stage the installation to a temp directory prior to packaging (allows for package building without root access). DESTDIR is called a staged installation by the GNU coding standards", 3 );
                append( sb, "", 0 );

                append( sb, "environment", 2 );
                append( sb, "make-maven-plugin will define environment variables prior to execution of the commands that it dispatches", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreErrors (Default: false)", 2 );
                append( sb, "Configures the goal to ignore errors returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreFailures (Default: false)", 2 );
                append( sb, "Configures the goal to ignore failures returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreTestFailures", 2 );
                append( sb, "Whether we should prevent the test mojo from failing if there are test failures.", 3 );
                append( sb, "", 0 );

                append( sb, "makeTestWorkDir", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );

                append( sb, "options", 2 );
                append( sb, "The command-line arguments to include in the command invocation. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "resolveOptions (Default: true)", 2 );
                append( sb, "resolveOptions is a setting to control if you want the make-maven-plugin to resolve @pathOf(..)@ expressions or not", 3 );
                append( sb, "", 0 );

                append( sb, "searchForExecutable (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "skipped (Default: false)", 2 );
                append( sb, "If set, the goal will be skipped", 3 );
                append( sb, "", 0 );

                append( sb, "skipTest (Default: false)", 2 );
                append( sb, "Whether we should skip testing this project. This is merely a short-circuit mechanism, since this mojo will be included in a standard lifecycle mapping.", 3 );
                append( sb, "", 0 );

                append( sb, "testCheckFile", 2 );
                append( sb, "A file which should be modified during the tests...if this is set and not updated, the mojo will fail.", 3 );
                append( sb, "", 0 );

                append( sb, "testCommand", 2 );
                append( sb, "The command we should invoke to run the tests.", 3 );
                append( sb, "", 0 );

                append( sb, "testOptions", 2 );
                append( sb, "Command-line options for use in the test command invocation. No expressions are currently supported here, other than those resolved inside the pom.xml.", 3 );
                append( sb, "", 0 );

                append( sb, "testTarget", 2 );
                append( sb, "The Make test target to execute.", 3 );
                append( sb, "", 0 );

                append( sb, "workDir (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "unpack".equals( goal ) )
        {
            append( sb, "make:unpack", 0 );
            append( sb, "Unpack a tar (or similar) target to unpack the distrution artifact. Goal exists only because of plexus bugs while handling tarballs. If plexus tar UnArchiver gets fixed, maven-dependency-plugin should be used instead.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "absoluteCommandPathUsed (Default: false)", 2 );
                append( sb, "Behavior to take command and use explicit pathing instead of using the shell\'s path", 3 );
                append( sb, "", 0 );

                append( sb, "chmodUsed (Default: false)", 2 );
                append( sb, "Configures the goal to change the make command to executable prior to invocation", 3 );
                append( sb, "", 0 );

                append( sb, "command (Default: make)", 2 );
                append( sb, "The shell command to execute. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "destDir", 2 );
                append( sb, "The classic autoconf/make DESTDIR parameter which tells make to stage the installation to a temp directory prior to packaging (allows for package building without root access). DESTDIR is called a staged installation by the GNU coding standards", 3 );
                append( sb, "", 0 );

                append( sb, "environment", 2 );
                append( sb, "make-maven-plugin will define environment variables prior to execution of the commands that it dispatches", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreErrors (Default: false)", 2 );
                append( sb, "Configures the goal to ignore errors returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "ignoreFailures (Default: false)", 2 );
                append( sb, "Configures the goal to ignore failures returned by the make command invocation", 3 );
                append( sb, "", 0 );

                append( sb, "options", 2 );
                append( sb, "The command-line arguments to include in the command invocation. NOTE: This is NOT a direct parameter. We need to allow the concrete implementations to specify their own params for this, so that we can allow all mojos to be configured from the same section of the plugin declaration without worrying about naming collisions.", 3 );
                append( sb, "", 0 );

                append( sb, "resolveOptions (Default: true)", 2 );
                append( sb, "resolveOptions is a setting to control if you want the make-maven-plugin to resolve @pathOf(..)@ expressions or not", 3 );
                append( sb, "", 0 );

                append( sb, "searchForExecutable (Default: false)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "skipped (Default: false)", 2 );
                append( sb, "If set, the goal will be skipped", 3 );
                append( sb, "", 0 );

                append( sb, "skipUnpack (Default: false)", 2 );
                append( sb, "Whether we should skip unpacking this project. This is merely a short-circuit mechanism, in case this mojo will be included in a standard lifecycle mapping.", 3 );
                append( sb, "", 0 );

                append( sb, "unpackCommand (Default: tar)", 2 );
                append( sb, "The command we should invoke to do the unpack", 3 );
                append( sb, "", 0 );

                append( sb, "unpackOptions", 2 );
                append( sb, "Command-line options for use in the unpack command invocation. If no values are passed in and the plugin recognizes the archive type, it will put in the normal options for tar.", 3 );
                append( sb, "", 0 );

                append( sb, "unpackTarget", 2 );
                append( sb, "The Make test target to execute.", 3 );
                append( sb, "", 0 );

                append( sb, "workDir (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "The temporary working directory where the project is actually built. By default, this is within the \'/target\' directory.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "validate-pom".equals( goal ) )
        {
            append( sb, "make:validate-pom", 0 );
            append( sb, "Validate that the required project property prefix is available in the current project before allowing it to continue. This property is required to allow @pathOf(..)@ style references work, as in the make plugin\'s mojos.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
